unit Unit1;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, Vcl.Controls, Vcl.StdCtrls, WEBLib.StdCtrls,
  WEBLib.WebCtrls;

type
  TForm1 = class(TWebForm)
    editName: TWebEdit;
    WebButton1: TWebButton;
    button_top: TWebButton;
    button_left: TWebButton;
    button_right: TWebButton;
    button_bottom: TWebButton;
    eyeSocket: TWebHTMLDiv;
    WebHTMLDiv1: TWebHTMLDiv;
    eyeBall: TWebHTMLDiv;
    eyeGlare: TWebHTMLDiv;
    WebButton2: TWebButton;
    WebButton3: TWebButton;
    WebButton4: TWebButton;
    WebButton5: TWebButton;
    WebButton6: TWebButton;
    WebButton7: TWebButton;
    WebButton8: TWebButton;
    WebButton9: TWebButton;
    WebButton10: TWebButton;
    WebButton11: TWebButton;
    WebButton12: TWebButton;
    WebButton13: TWebButton;
    WebButton14: TWebButton;
    WebButton15: TWebButton;
    WebButton16: TWebButton;
    WebButton17: TWebButton;
    btnJiggleOn: TWebButton;
    btnJiggleOff: TWebButton;
    btnSleep: TWebButton;
    WebHTMLDiv2: TWebHTMLDiv;
    WebButton18: TWebButton;
    divSwiper: TWebHTMLDiv;
    WebLabel1: TWebLabel;
    procedure WebButton1Click(Sender: TObject);
    procedure WebFormCreate(Sender: TObject);
    procedure btnJiggleOnClick(Sender: TObject);
    procedure btnJiggleOffClick(Sender: TObject);
    [async] procedure btnSleepClick(Sender: TObject);
    procedure WebButton18Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnJiggleOffClick(Sender: TObject);
begin
  // Turn Off Jiggly Buttons
  asm
    var jigglies = document.querySelectorAll('.jigglable');
    jigglies.forEach(jiggle => {
      jiggle.style.removeProperty('animation-name');
    });
  end;
end;

procedure TForm1.btnJiggleOnClick(Sender: TObject);
begin
  // Turn On Jiggly Buttons
  asm
    var jigglies = document.querySelectorAll('.jigglable');
    jigglies.forEach(jiggle => {
      jiggle.style.setProperty('animation-name','jiggling');
    });
  end;
end;

procedure TForm1.btnSleepClick(Sender: TObject);
begin
  btnSleep.Caption := 'Sleeping...';
  asm
    async function sleep(msecs) {
      return new Promise((resolve) =>setTimeout(resolve, msecs));
    }
    await sleep(5000);
  end;
  btnSleep.Caption := 'Go To Sleep';
end;

procedure TForm1.WebButton18Click(Sender: TObject);
var
  progressbars: TJSHTMLCollection;
  progressbar: TJSHTMLElement;
  i: Integer;
begin
  progressbars := document.getElementsByClassname('progress-bar');
  i := 0;
  while i < progressbars.length do
  begin
    (progressbars.items[i] as TJSHTMLElement).style.setProperty('height','50px');
    i := i + 1;
  end;


  progressbar := document.getElementById('progress-bar') as TJSHTMLElement;
  progressbar.style.setProperty('width','200px');


end;

procedure TForm1.WebButton1Click(Sender: TObject);
begin
  button_top.Top := 400;
  button_top.Left := 402;
  button_top.ElementHandle.style.setProperty('opacity','1');

  button_left.Top := 400;
  button_left.Left := 300;
  button_left.ElementHandle.style.setProperty('opacity','1');

  button_right.Top := 440;
  button_right.Left := 402;
  button_right.ElementHandle.style.setProperty('opacity','1');

  button_bottom.Top := 440;
  button_bottom.Left := 300;
  button_bottom.ElementHandle.style.setProperty('opacity','1');

  // Using the component normally
  editName.Text := '';
  editName.TextHint := 'Enter name';
  editName.ElementClassName := 'rounded border border-dark';

  // Get or set any attribute.
  editName.ElementHandle.setAttribute('spellcheck','true');
  console.log(editName.ElementHandle.getAttribute('spellcheck'));

  // Attributes without values can be set as well
  editName.ElementHandle.setAttribute('hidden','');
  editName.ElementHandle.removeAttribute('hidden');

  // Managing Classes
  editName.ElementHandle.className := 'rounded border border-dark';
  editName.ElementHandle.classList.Add('rounded');
  editName.ElementHandle.classList.Remove('border');
  editName.ElementHandle.ClassList.Replace('border-dark','border-secondary');

  // Managing Styles
  editName.ElementHandle.style.setProperty('border-width','2px');
  editName.ElementHandle.style.setProperty('filter','drop-shadow(0px 0px 2px blue)');
  editName.ElementHandle.style.setProperty('min-height','25px');
  editName.ElementHandle.style.removeProperty('width');

  // JavaScript equivalents - can also just run these from the console
  asm
    // Using the component normally
    editName.Text = '';
    editName.setAttribute('placeholder','Enter name');
    editName.className = 'rounded border border-dark';

    // Get or set any attribute.
    editName.setAttribute('spellcheck','true');
    console.log(editName.getAttribute('spellcheck'));

    // Attributes without values can be set as well
    editName.setAttribute('hidden','');
    editName.removeAttribute('hidden');

    // Managing Classes
    editName.className = 'rounded border border-dark';
    editName.classList.add('rounded');
    editName.classList.remove('border');
    editName.classList.replace('border-dark','border-secondary');

    // Managing Styles
    editName.style.setProperty('border-width','2px');
    editName.style.setProperty('filter','drop-shadow(0px 0px 2px blue)');
    editName.style.setProperty('min-height','25px');
    editName.style.removeProperty('width');
  end;


end;

procedure TForm1.WebFormCreate(Sender: TObject);
begin
  button_top.Top := 300;
  button_top.Left := 400;
  button_top.ElementHandle.style.setProperty('opacity','0');

  button_left.Top := 400;
  button_left.Left := 200;
  button_left.ElementHandle.style.setProperty('opacity','0');

  button_right.Top := 440;
  button_right.Left := 500;
  button_right.ElementHandle.style.setProperty('opacity','0');

  button_bottom.Top := 500;
  button_bottom.Left := 300;
  button_bottom.ElementHandle.style.setProperty('opacity','0');

  // Setup Jiggly Buttons
  asm
    var jigglies = document.querySelectorAll('.jigglable');
    jigglies.forEach(jiggle => {
      jiggle.style.setProperty('transform-origin',parseInt(10+Math.random()*80)+'% '+parseInt(10+Math.random()*80)+'%');
      jiggle.style.setProperty('animation-duration',0.15+Math.random()*0.15+'s');
      jiggle.style.setProperty('animation-iteration-count','infinite');
      jiggle.style.setProperty('animation-direction','alternate');
      jiggle.style.setProperty('animation-timing-function','ease-in-out');
    })
  end;


  asm
    var slides = '';
    var slideprefix = '<div class="swiper-slide" style="display:flex; justify-content:center; width:125px;"><div class="p-1 m-1 bg-primary text-white rounded" style="width:125px;">';
    var slidesuffix = '</div></div>';

    slides += slideprefix+'abc'+slidesuffix;
    slides += slideprefix+'def'+slidesuffix;
    slides += slideprefix+'ghi'+slidesuffix;
    slides += slideprefix+'jkl'+'<span style="font-size:8px; color:black;"><br/>more info</span>'+slidesuffix;
    slides += slideprefix+'mno'+slidesuffix;

    divSwiper.firstElementChild.firstElementChild.firstElementChild.innerHTML = slides;

    // Create the main slider
    const swiper = new Swiper('.swiper', {
      slidesPerView: "auto",
      spaceBetween: 5,
      navigation: {
        nextEl: '.swiper-button-next',
        prevEl: '.swiper-button-prev',
      }
    });

  end;

end;

end.
